blog/urls.py
from . import views
from django.urls import path

urlpatterns = [
    path('', views.PostList.as_view(), name='home'),
    path('register/', views.registerPage, name='register'),
    path('login/', views.loginPage, name='login'),
    path('logout/', views.logoutuser, name='logout'),
    path('<slug:slug>/', views.post_detail, name='post_detail'),

]

myblog/urls.py
from django.contrib import admin
from django.urls import path, include
urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls')),
]

blog/models.py
from django.contrib.auth.models import User
from django.db import models

STATUS = ((0, "Draft"), (1, "Publish"))


class Post(models.Model):
    title = models.CharField(max_length=200, unique=True)
    slug = models.SlugField(max_length=200, unique=True)
    author = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name="blog_posts"
    )
    updated_on = models.DateTimeField(auto_now=True)
    content = models.TextField()
    created_on = models.DateTimeField(auto_now_add=True)
    status = models.IntegerField(choices=STATUS, default=0)

    class Meta:
        ordering = ["-created_on"]

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        from django.urls import reverse

        return reverse("post_detail", kwargs={"slug": str(self.slug)})


class Comment(models.Model):
    post = models.ForeignKey(
        Post, on_delete=models.CASCADE, related_name="comments")
    name = models.CharField(max_length=80)
    email = models.EmailField()
    body = models.TextField()
    created_on = models.DateTimeField(auto_now_add=True)
    active = models.BooleanField(default=False)

    class Meta:
        ordering = ["created_on"]

    def __str__(self):
        return "Comment {} by {}".format(self.body, self.name)

blog/forms.py
from .models import Comment
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User


class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ('name', 'email', 'body')


class CreateUserForm(UserCreationForm):
    class Meta:
        model = User
        fields = ('username', 'email', 'password1', 'password2')


class EmailPostForm(forms.Form):
    name = forms.CharField(max_length=25)
    email = forms.EmailField()
    to = forms.EmailField()
    comment = forms.CharField(required=False, widget=forms.Textarea)

blog/views.py
from django.contrib.auth.forms import UserCreationForm
from django.views import generic
from .models import Post
from .forms import CommentForm, CreateUserForm, EmailPostForm
from django.shortcuts import render, get_object_or_404, redirect

from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator


def class_view_decorator(function_decorator):
    """Convert a function based decorator into a class based decorator usable
    on class based Views.

    Can't subclass the `View` as it breaks inheritance (super in particular),
    so we monkey-patch instead.
    """

    def simple_decorator(View):
        View.dispatch = method_decorator(function_decorator)(View.dispatch)
        return View

    return simple_decorator


@class_view_decorator(login_required(login_url='login'))
class PostList(generic.ListView):
    queryset = Post.objects.filter(status=1).order_by('-created_on')
    template_name = 'index.html'
    paginate_by = 5


@login_required(login_url='login')
def post_detail(request, slug):
    template_name = 'post_detail.html'
    post = get_object_or_404(Post, slug=slug)
    comments = post.comments.filter(active=True)
    new_comment = None
    # Comment posted
    if request.method == 'POST':
        comment_form = CommentForm(data=request.POST)
        if comment_form.is_valid():

            # Create Comment object but don't save to database yet
            new_comment = comment_form.save(commit=False)
            # Assign the current post to the comment
            new_comment.post = post
            # Save the comment to the database
            new_comment.save()
    else:
        comment_form = CommentForm()

    return render(request, template_name, {'post': post,
                                           'comments': comments,
                                           'new_comment': new_comment,
                                           'comment_form': comment_form})


def registerPage(request):
    if request.user.is_authenticated:
        return redirect('home')
    else:
        form = CreateUserForm()
        if request.method == 'POST':
            form = CreateUserForm(request.POST)
            if form.is_valid():
                form.save()
                user = form.cleaned_data.get('username')
                messages.success(request, 'Account was created for' + user)
                return redirect('login')

        context = {'form': form}
        return render(request, 'register.html', context)


def loginPage(request):
    if request.user.is_authenticated:
        return redirect('home')
    else:
        if request.method == 'POST':
            username = request.POST.get('username')
            password = request.POST.get('password')

            user = authenticate(request, username=username, password=password)

            if user is not None:
                login(request, user)
                return redirect('home')
            else:
                messages.info(request, "username or password is incorrect")
        context = {}
        return render(request, 'login.html', context)


def logoutuser(request):
    logout(request)
    return redirect('login')


def post_share(request, post_id):
    post = get_object_or_404(Post, id=post_id, status='published')
    if request.method == 'POST':
        form = EmailPostForm(request.POST)
        if form.is_valid():
            cd = form.cleaned_data
            # send email
        else:
            form = EmailPostForm()
        return render(request, 'share.html', {'post': post, 'form': form})

blog/templates/base.html
{% load static %}

<!DOCTYPE html>
<html>




<head>
    <title>MY BLOG</title>


    <link href="https://fonts.googleapis.com/css?family=Roboto:400,700" rel="stylesheet">
    <meta name="google" content="notranslate" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous" />

</head>

<body>

    <style>
        #hello-message {
            font-size: 18px;
            color: rgb(19, 1, 1);
            margin: right 20px;
        }
    </style>

    <style>
        body,
        html {
            margin: 0;
            padding: 0;
            height: 100%;
            background: #7abecc !important;
        }


        .row {
            width: 100%;
            color: rgb(12, 1, 1) !important;
        }
    </style>


    <!-- Navigation -->
    <nav class="navbar navbar-expand-lg navbar-light bg-light shadow" id="mainNav">
        <div class="container-fluid">
            <a class="navbar-brand" href="{% url 'home' %}">MY BLOG</a>
            <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse"
                data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false"
                aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse" id="navbarResponsive">
                <ul class="navbar-nav ml-auto">

                    <span id="hello-msg">Hello,{{request.user}}</span>
                    <span><a href="{%url 'logout'%}">Logout</a></span>
                </ul>
            </div>
        </div>
        </div>
    </nav>


    {% block content %}
    <!-- Content Goes here -->
    {% endblock content %}

    <!-- Footer -->
    <footer class=" py-3 bg-grey">
        <p class="m-0 text-dark text-center ">Copyright &copy; PAWAN GUPTA</p>
    </footer>
    <!-- bootstrap scripts -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
        integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous">
        </script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"
        integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous">
        </script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"
        integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous">
        </script>
</body>




</html>

blog/templates/index.html
{% extends "base.html" %}

{% block content %}




<header class="masthead">
    <div class="overlay"></div>
    <div class="container">
        <div class="row">
            <div class=" col-md-8 col-md-10 mx-auto">
                <div class="site-heading">
                    <h3 class=" site-heading my-4 mt-3 text-white"> Welcome to my awesome Blog </h3>
                    <p class="text-light">We Love Django As much as you do &nbsp
                    </p>
                </div>
            </div>
        </div>
    </div>
    </div>
</header>

<div class="container">
    <div class="row">

        <!-- Blog Entries Column -->
        <div class="col-md-8 mt-3 left">
            {% for post in post_list %}
            <div class="card mb-4">
                <div class="card-body">
                    <h2 class="card-title">{{ post.title }}</h2>
                    <p class="card-text text-muted h6">{{ post.author }} | {{ post.created_on}} </p>

                    <p class="card-text">{{post.content|safe|slice:":200" }}</p>
                    <a href="{% url 'post_detail' post.slug  %}" class="btn btn-primary">Read More &rarr;</a>
                </div>

            </div>
            {% endfor %}

        </div>
        {% block sidebar %}
        {% include 'sidebar.html' %}
        {% endblock sidebar %}
    </div>
</div>
{% if is_paginated %}
<nav aria-label="Page navigation conatiner"></nav>
<ul class="pagination justify-content-center">
    {% if page_obj.has_previous %}
    <li><a href="?page={{ page_obj.previous_page_number }}" class="page-link">&laquo; PREV </a></li>
    {% endif %}
    {% if page_obj.has_next %}
    <li><a href="?page={{ page_obj.next_page_number }}" class="page-link"> NEXT &raquo;</a></li>

    {% endif %}
</ul>
</nav>
</div>
{% endif %}
{%endblock%}

blog/templates/login.html
{% extends "base.html" %}

{% block content %}
<!DOCTYPE html>
<html>

<head>
    <title>Login</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
        integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.1/css/all.css"
        integrity="sha384-gfdkjb5BdAXd+lj+gudLWI+BXq4IuLW5IT+brZEZsLFm++aCMlF1V92rMkPaX4PP" crossorigin="anonymous">


    <style>
        body,
        html {
            margin: 0;
            padding: 0;
            height: 100%;
            background: #7abecc !important;
        }

        .user_card {
            width: 350px;
            margin-top: auto;
            margin-bottom: auto;
            background: #74cfbf;
            position: relative;
            display: flex;
            justify-content: center;
            flex-direction: column;
            padding: 10px;
            box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
            -webkit-box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
            -moz-box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
            border-radius: 5px;

        }

        .form_container {
            margin-top: 20px;
        }

        #form-title {
            color: #fff;

        }

        .login_btn {
            width: 100%;
            background: #33ccff !important;
            color: white !important;
        }

        .login_btn:focus {
            box-shadow: none !important;
            outline: 0px !important;
        }

        .login_container {
            padding: 0 2rem;
        }

        .input-group-text {
            background: #f7ba5b !important;
            color: white !important;
            border: 0 !important;
            border-radius: 0.25rem 0 0 0.25rem !important;
        }

        .input_user,
        .input_pass:focus {
            box-shadow: none !important;
            outline: 0px !important;
        }

        #messages {
            background-color: grey;
            color: #fff;
            padding: 10px;
            margin-top: 10px;
        }
    </style>

</head>

<body>
    <div class="container h-100">
        <div class="d-flex justify-content-center h-100">
            <div class="user_card">
                <div class="d-flex justify-content-center">


                    <h3 id="form-title">LOGIN</h3>
                </div>
                <div class="d-flex justify-content-center form_container">
                    <form method="POST" action="">
                        {%csrf_token%}
                        <div class="input-group mb-3">
                            <div class="input-group-append">
                                <span class="input-group-text"><i class="fas fa-user"></i></span>
                            </div>
                            <input type="text" name="username" placeholder="Username..." class="form-control">
                        </div>
                        <div class="input-group mb-2">
                            <div class="input-group-append">
                                <span class="input-group-text"><i class="fas fa-key"></i></span>
                            </div>
                            <input type="password" name="password" placeholder="Password..." class="form-control">
                        </div>

                        <div class="d-flex justify-content-center mt-3 login_container">
                            <input class="btn login_btn" type="submit" value="Login">
                        </div>
                    </form>

                </div>
                {%for message in messages %}
                {%endfor%}
                <div class="mt-4">
                    <div class="d-flex justify-content-center links">
                        Don't have an account? <a href="{% url 'register' %}" class="ml-2">Sign Up</a>
                    </div>

                </div>
            </div>
        </div>
    </div>
</body>

</html>
{%endblock%}

blog/templates/post_detail.html
{% extends 'base.html' %} {% block content %}
{% load crispy_forms_tags %}

<div class="container">
    <div class="row">
        <div class="col-md-8 card mb-4  mt-3 left  top">
            <div class="card-body">
                <h1>{% block title %} {{ post.title }} {% endblock title %}</h1>
                <p class=" text-muted">{{ post.author }} | {{ post.created_on }}</p>
                <p class="card-text ">{{ post.content | safe }}</p>
            </div>
        </div>
        {% block sidebar %} {% include 'sidebar.html' %} {% endblock sidebar %}

        <div class="col-md-8 card mb-4  mt-3 ">
            <div class="card-body">
                <!-- comments -->
                {% with comments.count as total_comments %}
                <h2>{{ total_comments }} comments</h2>

                <p>
                    {% endwith %} {% for comment in comments %}
                </p>

                <div class="comments" style="padding: 10px;">
                    <p class="font-weight-bold">
                        {{ comment.name }}
                        <span class=" text-muted font-weight-normal">
                            {{ comment.created_on }}
                        </span>
                    </p>
                    {{ comment.body | linebreaks }}
                </div>

                {% endfor %}
            </div>
        </div>
        <div class="col-md-8 card mb-4  mt-3 ">
            <div class="card-body">
                {% if new_comment %}
                <div class="alert alert-success" role="alert">
                    Your comment is awaiting moderation
                </div>
                {% else %}
                <h3>Leave a comment</h3>
                <form method="post" style="margin-top: 1.3em;">
                    {{ comment_form | crispy }}
                    {% csrf_token %}
                    <button type="submit" class="btn btn-primary  btn-lg">Submit</button>
                </form>
                {% endif %}
            </div>
        </div>
    </div>
</div>

{% endblock content %}

blog/templates/register.html
{% extends "base.html" %}

{% block content %}
<!DOCTYPE html>
<html>

<head>
    <title>Login</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
        integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.1/css/all.css"
        integrity="sha384-gfdkjb5BdAXd+lj+gudLWI+BXq4IuLW5IT+brZEZsLFm++aCMlF1V92rMkPaX4PP" crossorigin="anonymous">

    <style>
        body,
        html {
            margin: 0;
            padding: 0;
            height: 100%;
            background: #7abecc !important;
        }

        .user_card {
            width: 350px;
            margin-top: auto;
            margin-bottom: auto;
            background: #74cfbf;
            position: relative;
            display: flex;
            justify-content: center;
            flex-direction: column;
            padding: 10px;
            box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
            -webkit-box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
            -moz-box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
            border-radius: 5px;

        }

        .form_container {
            margin-top: 20px;
        }

        #form-title {
            color: #fff;
        }

        .login_btn {
            width: 100%;
            background: #33ccff !important;
            color: white !important;
        }

        .login_btn:focus {
            box-shadow: none !important;
            outline: 0px !important;
        }

        .login_container {
            padding: 0 2rem;
        }

        .input-group-text {
            background: #f7ba5b !important;
            color: white !important;
            border: 0 !important;
            border-radius: 0.25rem 0 0 0.25rem !important;
        }

        .input_user,
        .input_pass:focus {
            box-shadow: none !important;
            outline: 0px !important;
        }
    </style>

</head>

<body>
    <div class="container h-100">
        <div class="d-flex justify-content-center h-100">
            <div class="user_card">
                <div class="d-flex justify-content-center">
                    <h3 id="form-title">REGISTER ACCOUNT</h3>
                </div>
                <div class="d-flex justify-content-center form_container">

                    <form method="POST" action="">
                        {%csrf_token%}
                        <div class="input-group mb-3">
                            <div class="input-group-append">
                                <span class="input-group-text"><i class="fas fa-user"></i></span>
                            </div>
                            {{form.username}}
                        </div>
                        <div class="input-group mb-2">
                            <div class="input-group-append">
                                <span class="input-group-text"><i class="fas fa-envelope-square"></i></span>
                            </div>
                            {{form.email}}
                        </div>
                        <div class="input-group mb-2">
                            <div class="input-group-append">
                                <span class="input-group-text"><i class="fas fa-key"></i></span>
                            </div>
                            {{form.password1}}
                        </div>
                        <div class="input-group mb-2">
                            <div class="input-group-append">
                                <span class="input-group-text"><i class="fas fa-key"></i></span>
                            </div>
                            {{form.password2}}
                        </div>

                        <div class="d-flex justify-content-center mt-3 login_container">
                            <input class="btn login_btn" type="submit" value="Register Account">
                        </div>
                    </form>
                </div>
                {{form.errors}}
                <div class="mt-4">
                    <div class="d-flex justify-content-center links">
                        Already have an account? <a href="{% url 'login' %}" class="ml-2">Login</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script>
        /* Because i didnt set placeholder values in forms.py they will be set here using vanilla Javascript
//We start indexing at one because CSRF_token is considered and input field 
*/

        //Query All input fields
        var form_fields = document.getElementsByTagName('input')
        form_fields[1].placeholder = 'Username..';
        form_fields[2].placeholder = 'Email..';
        form_fields[3].placeholder = 'Enter password...';
        form_fields[4].placeholder = 'Re-enter Password...';


        for (var field in form_fields) {
            form_fields[field].className += ' form-control'
        }
    </script>
</body>

</html>
{%endblock%}

blog/templates/sidebar.html
{% block sidebar %}



<!-- Sidebar Widgets Column -->
<div class="col-md-4 float-right ">
    <div class="card my-4">
        <h5 class="card-header">About Us</h5>
        <div class="card-body">
            <p class="card-text"> This awesome blog is made with Python Framework Django,and CSS framework bootstrap
            </p>
            <a href="#" class="btn btn-danger">Know more</a>
        </div>
    </div>
</div>

{% endblock sidebar %}